/* djb software */

#define FMT_ULONG 40 /* enough space to hold 2^128 - 1 in decimal, plus \0 */
#define FMT_LEN ((char *) 0) /* convenient abbreviation */

unsigned int scan_ulong(s,u) register char *s; register unsigned long *u;
{
  register unsigned int pos; register unsigned long result;
  register unsigned long c;
  pos = 0; result = 0;
  while ((c = (unsigned long) (unsigned char) (s[pos] - '0')) < 10)
    { result = result * 10 + c; ++pos; }
  *u = result; return pos;
}

unsigned int fmt_str(s,t)
register char *s; register char *t;
{
  register unsigned int len;
  char ch;
  len = 0;
  if (s) { while (ch = t[len]) s[len++] = ch; }
  else while (t[len]) len++;
  return len;
}

unsigned int fmt_ulong(s,u) register char *s; register unsigned long u;
{
  register unsigned int len; register unsigned long q;
  len = 1; q = u;
  while (q > 9) { ++len; q /= 10; }
  if (s) {
    s += len;
    do { *--s = '0' + (u % 10); u /= 10; } while(u); /* handles u == 0 */
  }
  return len;
}

unsigned int fmt_uint(s,u) register char *s; register unsigned int u;
{
  register unsigned long l; l = u; return fmt_ulong(s,l);
}

unsigned int fmt_uint0(s,u,n) char *s; unsigned int u; unsigned int n;
{
  unsigned int len;
  len = fmt_uint(FMT_LEN,u);
  while (len < n) { if (s) *s++ = '0'; ++len; }
  if (s) fmt_uint(s,u);
  return len;
}

struct datetime {
  int hour;
  int min;
  int sec;
  int wday;
  int mday;
  int yday;
  int mon;
  int year;
} ;

void datetime_get(dt,t)
struct datetime *dt;
time_t t;
{
  int day;
  int tod;
  int year;
  int yday;
  int wday;
  int mon;
 
  tod = t % 86400;
  day = t / 86400;
  if (tod < 0) { tod += 86400; --day; }
 
  dt->hour = tod / 3600;
  tod %= 3600;
  dt->min = tod / 60;
  dt->sec = tod % 60;
 
  wday = (day + 4) % 7; if (wday < 0) wday += 7;
  dt->wday = wday;
 
  day -= 11017;
  /* day 0 is march 1, 2000 */
  year = 5 + day / 146097;
  day = day % 146097; if (day < 0) { day += 146097; --year; }
  /* from now on, day is nonnegative */
  year *= 4;
  if (day == 146096) { year += 3; day = 36524; }
  else { year += day / 36524; day %= 36524; }
  year *= 25;
  year += day / 1461;
  day %= 1461;
  year *= 4;
  yday = (day < 306);
  if (day == 1460) { year += 3; day = 365; }
  else { year += day / 365; day %= 365; }
  yday += day;
 
  day *= 10;
  mon = (day + 5) / 306;
  day = day + 5 - 306 * mon;
  day /= 10;
  if (mon >= 10) { yday -= 306; ++year; mon -= 10; }
  else { yday += 59; mon += 2; }
 
  dt->yday = yday;
  dt->year = year - 1900;
  dt->mon = mon;
  dt->mday = day + 1;
}

static char *montab[12] = {
"Jan","Feb","Mar","Apr","May","Jun","Jul","Aug","Sep","Oct","Nov","Dec"
};


/* 
Message-Id: <20030811090830.14846.smtppipe@>r
Date: 11 Aug 2003 09:41:30 -0000r
*/
#include <time.h>

void mk_date(int sock, int seen_date, int seen_msgid, char *name) {
  char *s,*buf;
  time_t t;
  unsigned int len,i;
  struct datetime *dt, date_utc;

  buf = stralloc(NULL, 90+strlen(name));
  s = buf;
  t = time(0);
  dt = &date_utc;
  datetime_get(dt, t);	      

  len = 0;
  if (!seen_date) {
    i = fmt_str(s,"Date: "); len += i; if (s) s += i;
    i = fmt_uint(s,dt->mday); len += i; if (s) s += i;
    i = fmt_str(s," "); len += i; if (s) s += i;
    i = fmt_str(s,montab[dt->mon]); len += i; if (s) s += i;
    i = fmt_str(s," "); len += i; if (s) s += i;
    i = fmt_uint(s,dt->year + 1900); len += i; if (s) s += i;
    i = fmt_str(s," "); len += i; if (s) s += i;
    i = fmt_uint0(s,dt->hour,2); len += i; if (s) s += i;
    i = fmt_str(s,":"); len += i; if (s) s += i;
    i = fmt_uint0(s,dt->min,2); len += i; if (s) s += i;
    i = fmt_str(s,":"); len += i; if (s) s += i;
    i = fmt_uint0(s,dt->sec,2); len += i; if (s) s += i;
    i = fmt_str(s," -0000\r\n"); len += i; if (s) s += i;
  }

  if (!seen_msgid) {
    i = fmt_str(s,"Message-Id: <"); len += i; if (s) s += i;
    i = fmt_uint(s, dt->year + 1900); len += i; if (s) s += i;
    i = fmt_uint0(s,dt->mon+1,2); len += i; if (s) s += i;
    i = fmt_uint0(s,dt->mday,2); len += i; if (s) s += i;
    i = fmt_uint0(s,dt->hour,2); len += i; if (s) s += i;
    i = fmt_uint0(s,dt->min,2); len += i; if (s) s += i;
    i = fmt_uint0(s,dt->sec,2); len += i; if (s) s += i;
    i = fmt_str(s,"."); len += i; if (s) s += i;
    i = fmt_ulong(s,getpid()); len += i; if (s) s += i;
    i = fmt_str(s,".smtppipe@"); len += i; if (s) s += i;
    i = fmt_str(s,name); len += i; if (s) s += i;
    i = fmt_str(s,">\r\n"); len += i; if (s) s += i;
  }

  i=write(sock,buf,len);
  if (i < 0) die("write(socket)", strerror(errno));
  if ((size_t) i != len)
    die("write(socket)", "could not write the whole data stream");

  free(buf);
}
